clear all;
close all;

%lecture de la matrice d'ordre 128
load ij128;

nb_iter = 500;
nb_images = 21;
index_im_ref = 0;
% root_image_name = sprintf('Resonance_439_9Hz');
root_image_name = sprintf('Resonance_439_8Hz');

suffixe = sprintf('_%d.tif', index_im_ref);
name_image_ref = strcat(root_image_name, suffixe);
image_ref=imread(name_image_ref,'tif');
im1 = image_ref(1:128,1:128);

%%%%%   Calcul des dcalages    %%%%%%%%%%
for index = 1 : nb_images
    suffixe = sprintf('_%d.tif', index-1);
    name_image_current = strcat(root_image_name, suffixe);
    image_current = imread(name_image_current,'tif');
    im2 = image_current(1:128,1:128);
    [dx(index),dy(index)] = calcul_decalage_2(128, 500, im1, im2, ij, index);
    %calcul du dcalage local entre ces deux images avec les paramtres suivants :
    % #1 : 128 taille des images (8, 16, 32, 64, 128 ou 256)
    % #2 : nombre d'itrations effectu
    % #3 : nom de la premire image
    % #4 : nom de la seconde image
    % #5 : nom de la matrice d'ordre  utiliser
    
    if (rem (index , 10) == 0)
        index
    end
end

figure;     colormap('gray');
imagesc(im1);
axis square;
title('Image utilise en rfrence');

figure;
plot(dx, 'r', 'LineWidth', 1);
hold on;
plot(dy, 'b', 'LineWidth', 1);
title('Displacement at 439.9Hz in X (red) and Y (blue)');
xlabel('Image number');
ylabel('Displacement (pixel)');

