% function calcul_decalage.m()
% 
% Retourne le dcalage entre deux images de speckle identiques par
% minimisation de sa partie antisym .
% par estimation/correction (Algorithme E. LANTZ)
% dx et dy sont inverss p.r  la version prcdente
% version avec paramtres : dim,iterat,im1,im2,tabij,

function [depx,depy]=calcul_decalage(dim,iterat,im1,im2,tabij, index)

trace_convergence = 1;

ic=dim/2+1;
if (iterat < (dim*(dim-1)/2-1)),
  nbre=iterat;
else
  nbre=(dim*(dim-1))/2-1;	%nombre de points pris en compte pour le calcul final
end;

% -------- Calcul T.F. image 1 (re,im,mod,phase) ---------

%toc;
fim1=fftshift(fft2(im1));
  clear im1;
  mod=abs(fim1);
  phase1=atan(imag(fim1)./real(fim1));
  clear fim1;


% ----- Remplace NaNs par zeros dans phase 1 ------

  i=find(isnan(phase1));
  phase1(i)=zeros(size(i));
  clear i;


% -------- Calcul T.F. image 2 (re,im,mod,phase) --------- 

%toc;
  fim2=fftshift(fft2(im2));
  clear im2;
  phase2=atan(imag(fim2)./real(fim2));
  clear fim2;


% ----- Remplace NaNs par zeros dans phase 2------

  i=find(isnan(phase2));
  phase2(i)=zeros(size(i));
  clear i;


%------- soustraction des phases ----------

  phase=phase2-phase1;
  clear phase1;
  clear phase2;

%---- p=1 --> kx=1 et ky=0
	n=round(phase(ic,ic+1)/pi);
	denx=mod(ic,ic+1).^2;
	NSX=denx*(phase(ic,ic+1)-n*pi);
	p0x=phase(ic,ic+1)-n*pi;

%---- p=2 --> kx=0 et ky=1
	n=round(phase(ic+1,ic)/pi);
	deny=mod(ic+1,ic).^2;
	NSY=deny*(phase(ic+1,ic)-n*pi);
	p0y=phase(ic+1,ic)-n*pi;

%-------initialisation de paramtres
	num2=0;
	facteur=dim/(2*pi);


%--- stockage rsultats intermdiaires ds tableaux suivants :
	ddy=zeros(nbre,1);		%-- variations dcalages
	ddx=zeros(nbre,1);		
	ddy(3)=-p0y*facteur;
	ddx(3)=-p0x*facteur;

% ------------- itration ----------------
  for p=3:nbre,
	i=tabij(1,p);
	j=tabij(2,p);
	phas=phase(i,j);
	module=mod(i,j).^2;
	diffi=i-ic;
	diffj=j-ic;
	n=round((phas-diffi*p0y-diffj*p0x)/pi);
	NSY=NSY+diffi*module*(phas-n*pi);
	deny=deny+diffi.^2*module;
	NSX=NSX+diffj*module*(phas-n*pi);
	denx=denx+diffj.^2*module;
	num2=num2+module*diffi*diffj;
	denom=denx*deny-num2^2;
	p0x=(deny*NSX-num2*NSY)/denom;
	p0y=(denx*NSY-num2*NSX)/denom;
	ddy(p+1)=-p0y*facteur;
	ddx(p+1)=-p0x*facteur;
  end;
  
% ............... recalage sur un pole centr au cas o ....

if ddx(p)>dim/4
  depx=(ddx(p)-dim/2);
elseif ddx(p)<-dim/4
  depx=(ddx(p)+dim/2);
else
  depx=ddx(p);
end;
if ddy(p)>dim/4
  depy=(ddy(p)-dim/2);
elseif ddy(p)<-dim/4
  depy=(ddy(p)+dim/2);
else
  depy=ddy(p);
end;


% if ddx(p)>dim/4
%   depx=-(ddx(p)-dim/2);
% elseif ddx(p)<-dim/4
%   depx=-(ddx(p)+dim/2);
% else
%   depx=-ddx(p);
% end;
% if ddy(p)>dim/4
%   depy=-(ddy(p)-dim/2);
% elseif ddy(p)<-dim/4
%   depy=-(ddy(p)+dim/2);
% else
%   depy=-ddy(p);
% end;


if trace_convergence
    figure;
    clf;
    hold on;
    plot(ddx,'r');
    plot(ddy,'b');
    xlabel('Iteration index');
    ylabel('Estimated displacement');
    titre = sprintf('Displacements retrieved in X( red) and Y (blue); image: %d', index);
    title(titre);
end

